package jp.co.sds_corp.http.server;

import java.io.ByteArrayOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.util.Date;

public class Content
{
	String url;
	File file;
	MimeType mimeType;
	byte[] buf;
	Date lastUsed;

	Content(String url, File file) {
		this.url = url;
		this.file = file;
		lastUsed = new Date();
	}

	public static Content getContent(String url, File file) throws Exception {
		Content content = new Content(url, file);
		ByteArrayOutputStream bos = new ByteArrayOutputStream();
		FileInputStream is = null;
		try {
			is = new FileInputStream(file);
			byte[] buf = new byte[8192];
			for ( ;; ) {
				int ret = is.read(buf);
				if (ret < 0) {
					break;
				}
				bos.write(buf, 0, ret);
			}
		} finally {
			if (is != null) {
				try {
					is.close();
				} catch (Exception ex) {
				}
			}
		}
		content.setBytes(bos.toByteArray());
		return content;
	}

	void setURL(String var) {
		this.url = var;
	}
	public String getURL() {
		return this.url;
	}

	public File getFile() {
		return this.file;
	}

	void setMimeType(MimeType var) {
		this.mimeType = var;
	}
	public MimeType getMimeType() {
		return this.mimeType;
	}

	public Date getLastUsed() {
		return this.lastUsed;
	}

	void setBytes(String var) {
		this.buf = var.getBytes();
	}
	void setBytes(byte[] var) {
		this.buf = var;
		lastUsed = new Date();
	}
	public byte[] getBytes() {
		lastUsed = new Date();
		return this.buf;
	}

	@Override
	public String toString() {
		String ret = "url=" + url + " file=" + file + " mime=" + mimeType;
		if (buf != null) {
			ret += " size=" + buf.length;
		}
		return ret;
	}

}
