package jp.co.sds_corp.http.server;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.sds_corp.util.config.IConfigurable;
import jp.co.sds_corp.util.config.IConfiguration;

public class FixResponse implements Context, IConfigurable
{
	Map<String,HttpResponse> mapRes = new HashMap<String,HttpResponse>();
	List<HttpResponse> listRes = new ArrayList<HttpResponse>();
	int pos = 0;

	@Override
	public void init( IConfiguration config ) throws Exception {
		List<IConfiguration> list;
		list = config.listChild("response");
		for (IConfiguration resCfg : list) {
			HttpResponse res = HttpResponse.createResponse(resCfg);
			if (res.getURL() != null) {
				mapRes.put(res.getURL(), res);
			} else {
				listRes.add(res);
			}
		}
	}

	@Override
	public void start() {
	}

	@Override
	public void stop() {
	}

	@Override
	public boolean match(HttpRequest request) {
		if (listRes.size() > 0) {
			return true;
		}
		HttpResponse response = mapRes.get(request.getQueryString());
		if (response != null) {
			return true;
		}
		return false;
	}

	@Override
	public void service(HttpRequest request, HttpResponse response)
		throws Exception
	{
		HttpResponse found = findResponse(request);
		if (found != null) {
			response.copyAll(found);
		}
	}

	HttpResponse findResponse(HttpRequest request) {
		HttpResponse response = null;
		response = mapRes.get(request.getQueryString());
		if (response == null) {
			if (listRes.size() > 0) {
				response = listRes.get(pos);
				pos++;
				if (pos >= listRes.size()) {
					pos = 0;
				}
			}
		}

		return response;
	}

}
