package jp.co.sds_corp.http.server;

import java.util.Enumeration;
import java.util.HashMap;
import java.util.Iterator;
import java.util.Map;

public class HttpRequest
{
	Map<String,String> mapHeader = new HashMap<String,String>();
	Map<String,String> mapParam = new HashMap<String,String>();
	String remoteAddr;
	String method;
	String query;
	String protocol;
	String content;
	int contentLength;

	protected HttpRequest() {
	}

	void putHeaders(Map<String,String> map) {
		mapHeader.putAll(map);
	}
	void putHeader(String name, String value) {
		mapHeader.put(name, value);
	}
	public String getHeader(String name) {
		return mapHeader.get(name);
	}
	public Enumeration<Object> getHeaderNames() {
		return toEnumeration(mapHeader.keySet().iterator());
	}

	void putParameters(Map<String,String> map) {
		mapParam.putAll(map);
	}
	void putParameter(String name, String value) {
		mapParam.put(name, value);
	}
	public String getParameter(String name) {
		return mapParam.get(name);
	}
	public Enumeration<Object> getParameterNames() {
		return toEnumeration(mapParam.keySet().iterator());
	}

	private Enumeration<Object> toEnumeration(final Iterator<String> iterator) {
		return new Enumeration<Object>() {
			public boolean hasMoreElements() {
				return iterator.hasNext();
			}
			public Object nextElement() {
				return iterator.next();
			}
		};
	}

	void setRemoteAddr(String var) {
		this.remoteAddr = var;
	}
	public String getRemoteAddr() {
		return this.remoteAddr;
	}

	void setMethod(String var) {
		this.method = var;
	}
	public String getMethod() {
		return this.method;
	}

	void setQueryString(String var) {
		this.query = var;
	}
	public String getQueryString() {
		return this.query;
	}

	void setProtocol(String var) {
		this.protocol = var;
	}
	public String getProtocol() {
		return this.protocol;
	}

	void setContent(String var) {
		this.content = var;
	}
	public String getContent() {
		return this.content;
	}

	void setContentLength(int var) {
		this.contentLength = var;
	}
	public int getContentLength() {
		return this.contentLength;
	}

	@Override
	public String toString() {
		StringBuilder ret = new StringBuilder();
		ret.append(getMethod()).append(" ");
		ret.append(getQueryString()).append(" ");
		ret.append(getProtocol()).append("\n");
		ret.append("header=").append(mapHeader.toString()).append("\n");
		ret.append("param=").append(mapParam.toString());
		return ret.toString();
	}

}
