package jp.co.sds_corp.http.server;

import java.util.HashMap;
import java.util.List;
import java.util.Map;

import jp.co.sds_corp.util.config.ConfigUtil;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class ServletInfo
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	Map<String,String> mapParam = new HashMap<String,String>();
	String description;
	String displayName;
	String servletName;
	String servletClass;

	protected ServletInfo() {
	}

	public void init(IConfiguration config) throws Exception {
		setDescription(ConfigUtil.getChildText(config, "description"));
		setDisplayName(ConfigUtil.getChildText(config, "display-name"));
		setServletName(ConfigUtil.getChildText(config, "servlet-name"));
		setServletClass(ConfigUtil.getChildText(config, "servlet-class"));

		List<IConfiguration> list = config.listChild("init-param");
		for (IConfiguration prmCfg : list) {
			String name = ConfigUtil.getChildText(prmCfg, "param-name");
			String value = ConfigUtil.getChildText(prmCfg, "param-value");
			mapParam.put(name, value);
		}
		logger.trace(this, "load " + getDisplayName() + ","
			+ getServletName() + "," + getServletClass() + " "
			+ mapParam);
	}

	void putParameters(Map<String,String> map) {
		mapParam.putAll(map);
	}
	void putParameter(String name, String value) {
		mapParam.put(name, value);
	}
	public String getParameter(String name) {
		return mapParam.get(name);
	}

	void setDescription(String var) {
		this.description = var;
	}
	public String getDescription() {
		return this.description;
	}

	void setDisplayName(String var) {
		this.displayName = var;
	}
	public String getDisplayName() {
		return this.displayName;
	}

	void setServletName(String var) {
		this.servletName = var;
	}
	public String getServletName() {
		return this.servletName;
	}

	void setServletClass(String var) {
		this.servletClass = var;
	}
	public String getServletClass() {
		return this.servletClass;
	}

	@Override
	public String toString() {
		String ret = getServletName() + " " + getServletClass();
		ret += "init-param=" + mapParam;
		return ret;
	}

}
