package jp.co.sds_corp.http.server;

import java.util.regex.Pattern;

import jp.co.sds_corp.util.config.ConfigUtil;
import jp.co.sds_corp.util.config.IConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class ServletMapping
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	String servletName;
	String urlPattern;
	Pattern pattern;

	protected ServletMapping() {
	}

	public void init(IConfiguration config) throws Exception {
		setServletName(ConfigUtil.getChildText(config, "servlet-name"));
		setUrlPattern(ConfigUtil.getChildText(config, "url-pattern"));
		logger.trace(this, "mapping " + getUrlPattern() + "(" + pattern + ")"
			+ "->" + getServletName());
	}

	public boolean match(String query) {
		if (pattern == null) {
			return false;
		}
		return pattern.matcher(query).matches();
	}

	void setServletName(String var) {
		this.servletName = var;
	}
	public String getServletName() {
		return this.servletName;
	}

	void setUrlPattern(String var) {
		this.urlPattern = var;
		String conv = var.replaceAll("\\.", "\\\\.");
		conv = conv.replaceAll("\\?", "\\.");
		conv = conv.replaceAll("\\*", ".*");
		this.pattern = Pattern.compile(conv);
	}
	public String getUrlPattern() {
		return this.urlPattern;
	}

	@Override
	public String toString() {
		String ret = getUrlPattern() + "=" + getServletName();
		return ret;
	}

}
