package jp.co.sds_corp.http.server;

import jp.co.sds_corp.test.BasicTestCase;
import jp.co.sds_corp.util.config.DOMConfiguration;
import jp.co.sds_corp.util.log.CmnLogFactory;
import jp.co.sds_corp.util.log.CmnLogger;

public class HttpServerTest extends BasicTestCase
{
	static final CmnLogger logger = CmnLogFactory.getLogger();
	HttpServer server;

	@Override
	public void setUp() throws Exception {
		super.setUp();

		server = new HttpServer();
		DOMConfiguration config = new DOMConfiguration("target/test-classes/httpserver.xml");
		server.init(config);
	}

	public void testPrintConfig() throws Exception {
		server.start();
		String ret = server.printConfig();
		logger.debug(this, "ret=" + ret);
		server.stop();
	}

	public void testPrintCache() throws Exception {
		server.start();
		String ret = server.printCache();
		logger.debug(this, "ret=" + ret);
		server.stop();
	}

	public void testPrintMime() throws Exception {
		server.start();
		String ret = server.printMime();
		logger.debug(this, "ret=" + ret);
		server.stop();
	}

}
